//+---------------------------------------------------------------------------
//  PAZZMA_LIB.C - Windows GUI v.0.9
//  by Slava Razbickiy - rasla@mail.ru
//+---------------------------------------------------------------------------

#include <math.h>

HWND hWnd, hProgress, hStat;
HINSTANCE hInst;
SYSTEMTIME t;

#define sqrt2 1.414213562373 // sqrt(2)=1.414213562373; -   TestLowFreq(), SaveReport()
double const dMAXIMUMint = 32.768; //32768 -   "signed WORD"

char	ProgName[]="  0.9",ProgClass[]="PazzmaC";
//  PAR-
char    ParTag[]="2571090,1618190";
//   INI-
char    pzzm[]="pzzm",PzzmNumtext[]="PzzmNum",lfile[]="LastFile";
char    Uetext[]="Ue",Ue50text[]="Ue50",Uu50text[]="Uu50",sdir[]="SaveDir";
char	Ue[8],Ue50[8],Uu50[8],PzzmNum[12];

//     
char	Filt[]={"*.Dat; *.783; *.txt\0*.Dat;*.783;*.txt\0*.*\0*.*\0"};
//    ,  ,   
char	File[1024],Ext[12],SaveDir[1024],SaveName[1024];

//    WAV- - 0.5  / 44 100  / 2  / 16 
char	wavhead[]={
	0x52,0x49,0x46,0x46,0xAC,0x58,0x01,0x00,0x57,0x41,0x56,
	0x45,0x66,0x6D,0x74,0x20,0x10,0x00,0x00,0x00,0x01,0x00,
	0x02,0x00,0x44,0xAC,0x00,0x00,0x10,0xB1,0x02,0x00,0x04,
	0x00,0x10,0x00,0x64,0x61,0x74,0x61,0x88,0x58,0x01,0x00};
char	wave[sizeof(wavhead)+88200];	// RightWord,LeftWord... * 1 sec of 44100 Hz (16bit, Stereo)
char    wave_silent[sizeof(wavhead)+88200];

//   
char     useIO; //   -  LPT-
char     useUu; //      50 .
unsigned int   gStatus; //  

//        ,   
FILE    *FileR, *FileW;
int     readSize;
//      
void   *MemIn, *MemWork;
int     szWork; //  MemWork  

//        
int     nChannels, nSPC;
double  dMaximum;
//int     , SignalLimit, nChannelsAll, ChannelSize, DataSize;
int     LpData; //    ,   - (  .783  .TXT)
float   fStep; //    ()
//      
int StartOZZ,EndOZZ, OVZ1,OVZ2,OVZ31,OVZ32,OVZ4, okno;
int EndOVZ2, StartOVZ4, StartOkno;

//    
int xProgress;

//    WAV
float	kU,kU50,kUu,kT;
//   " "  " "
int Freq,Volt,Sel,Sel_Off;
int Amp,AmpH,AmpI;

//      
int U3Iop,U3Iom,U3Uop,U3Uom,U3Uo;

//  ,     
char	*lpChar, *lpEnd;
int     tInt; // WndProc(WM_INIT; WM_COMMAND, ID_CBX6), ConvertDat()
float   tFlt; // ConvertTXTpg3,
// 
char bu[1024],Report[1024],RepTxt[8192];

int WINAPI Status(LPSTR txt1, LPSTR txt2, LPSTR txt3, INT pb){ //       
	if(txt1 != (LPSTR)0) SendMessage(hStat, SB_SETTEXT, 0, (LPARAM)txt1);
	if(txt2 != (LPSTR)0) SendMessage(hStat, SB_SETTEXT, 1, (LPARAM)txt2);
	if(txt3 != (LPSTR)0) SendMessage(hStat, SB_SETTEXT, 2, (LPARAM)txt3);
	if(pb != -1) SendMessage(hProgress, PBM_SETPOS, (WPARAM)pb, 0);
 return 0;
}
//  
void __fastcall Error(char *text){			//    
	MessageBox( 0, text, ProgName, 0 );
}
/*void WINAPI DebugInt( char *str, int param ){ //   " + INT2STR (Int)"
char    log[128];
    sprintf( log, "%s %i\n", str, param );
    Error( log);
}*/
/*int WINAPI SaveChannel( int nChannel, int type){  //      "Channel-.mem"
short   *ls;
char    *ld;
    MemIn = malloc( nSPC * 9); // -xxxxx\r\n
// binary
    if( type == 0){
        ls = nSPC*nChannel + (short *) MemWork;
        tInt = nSPC*2;
    }
// text
    else{
        ld = (char *) MemIn;
        ls = nSPC*nChannel + (short *) MemWork;
        for( tInt=0; tInt<nSPC; tInt++){
            ld += sprintf( ld, "%d\r\n", *(ls) );
            ls++;
        }
        ls = (short *) MemIn;
        tInt = (int) (ld - (char *) MemIn);
    }
// file
    sprintf( bu, "Channel-%d.mem", nChannel);

    FileW = fopen( bu, "wb" ); // OverWrite
    tInt = sizeof( wave);
    if( (int) fwrite( ls, 1, tInt, FileW) != tInt )
        Error("   !");
    fclose( FileW);

    free( MemIn);
    return 1;
}*/
int SaveWav(){ //  WAV
    FileW = fopen( "pazzma.wav", "wb" ); // OverWrite
    tInt = sizeof( wave);
    if( (int) fwrite( wave, 1, tInt, FileW) != tInt )
        Error(" WAV -  !");
    fclose( FileW);
    return 1;
}
//    
void __fastcall AddPrint ( char *str, int param){
    sprintf( RepTxt +strlen(RepTxt), str, param);
}
void __fastcall AddVolt ( int value){
    if( !value ) sprintf( RepTxt +strlen(RepTxt), "\t-----");
    else sprintf( RepTxt +strlen(RepTxt), "\t%2.3f", (float) value/1000 );
}
void __fastcall AddMks ( int value){
    if( !value ) sprintf( RepTxt +strlen(RepTxt), "--------  ");
    else sprintf( RepTxt +strlen(RepTxt), "%f  ", (float) value *fStep /1000000 );
}
int WINAPI SaveReport( int flag){ //  
    Status( " ",0,0,98);
///  ר
//   
    sprintf( RepTxt, "/* ---      %s  %02d.%02d.%d --- */\r\n", PzzmNum, t.wDay, t.wMonth, t.wYear);
    AddPrint( "[.LOGv1 (cp1251) - %s ]\r\n\r\n", (DWORD) &ProgName[0] );
// " "
    sprintf( RepTxt +strlen(RepTxt), "[%02d:%02d:%02d] -  \r\n", t.wHour, t.wMinute, t.wSecond);
//  
    lpChar = Report;
// "1)    (U-):\n\n"
    if( *((char *) lpChar) == 1){
        AddPrint( "\r\n\r\n1)    (U-):\r\n", 0 );
        AddPrint( "Freq\\U  \t3Io+,\t3Io-,\t3Uo+,\t3Uo-", 0 );
        while ( *((char *) lpChar) == 1){ //    1,2,3
//  
            AddPrint( "\r\n%i   ", *((int *) (lpChar+1)) ); // Freq
            if( *((int *) (lpChar+1)) < 1000 ) AddPrint( "  ", 0 ); //  
            AddVolt( *((int *) (lpChar+5)) ); // U3Iop
            AddVolt( *((int *) (lpChar+9)) ); // U3Iom
            AddVolt( *((int *) (lpChar+13)) ); // U3Uop
            AddVolt( *((int *) (lpChar+17)) ); // U3Uom
            lpChar += 25;
           }
        }
// "2)     (U-):\n\n"
    if( *((char *) lpChar) == 2){
        AddPrint( "\r\n\r\n2)     (U-):\r\n\r\n", 0 );
        AddPrint( "Freq\\U  \t3Uo", 0 );
        while ( *((char *) lpChar) == 2){ //    4,5
//  
            AddPrint( "\r\n%i   ", *((int *) (lpChar+1)) ); // Freq
            if( *((int *) (lpChar+1)) < 1000 ) AddPrint( "  ", 0 ); //  
// U3Uo -  , ..   sqrt(2)
            AddVolt( (int) ((float) (*((int *) (lpChar+21)) / sqrt2)) ); // U3Uo
            lpChar += 25;
            }
        }
// "3)    ():\n"
    if( gStatus & NEEDTEST6 ){
        AddPrint( "\r\n\r\n3)    ():", 0 );
        AddPrint( "\r\n   - %s\r\n\r\n", (DWORD) &File[0] );

        AddPrint( "OVZ1      ", 0);
		AddPrint( "OVZ2      ", 0);
		AddPrint( "OVZ31     ", 0);
		AddPrint( "OVZ32     ", 0);
		AddPrint( "OVZ4      ", 0);
		AddPrint( "Okno\r\n", 0);

		AddMks( OVZ1);
		AddMks( OVZ2);
		AddMks( OVZ31);
		AddMks( OVZ32);
		AddMks( OVZ4);
		AddMks( okno);

        AddPrint( "\r\n\r\nStartOZZ - ", 0); AddMks( StartOZZ);
		AddPrint( "\r\nEndOZZ   - ", 0); AddMks( EndOZZ);
        AddPrint( "\r\n\r\nStartOkno - ", 0); AddMks( StartOkno);
        AddPrint( "\r\nStartOVZ4 - ", 0); AddMks( StartOVZ4);
        AddPrint( "\r\nEndOVZ2   - ", 0); AddMks( EndOVZ2);
        }
// " "
    GetLocalTime( &t);
    sprintf( RepTxt +strlen(RepTxt), "\r\n\r\n[%02d:%02d:%02d] -  \r\n\r\n", t.wHour, t.wMinute, t.wSecond);
///  ר
//       
    Status( " ",0,0,98);
    if( flag == AUTOSAVE){
        sprintf( SaveName, "%spzzm-%s.txt", SaveDir, PzzmNum);
//        strcpy( SaveName +sizeof( SaveName) -4, "ab"); // Append
        FileW = fopen( SaveName, "ab" ); // Append
        fseek( FileW, 0, SEEK_END);
        }
    else{
        strcpy( SaveName +GetModuleFileName( hInst, SaveName, sizeof(SaveName) ) -3, "txt");
//        strcpy( SaveName +sizeof( SaveName) -4, "wb");  // OverWrite
        FileW = fopen( SaveName, "wb" ); // OverWrite
        }
//  
    tInt = strlen( RepTxt);
    if( (int) fwrite( RepTxt, 1, tInt, FileW) != tInt ) Error("   !");
    fclose( FileW);
    return 1;
}
//     
int __fastcall PeriodLen( int freq, int num){ //    ( samples)
// freq -  
// num -  
// return -     
    tFlt = (float) (44100*2*num / freq);
    return (int)tFlt;
}
void __fastcall ClearWave(){   //  WAV-
    ZeroMemory( wave, sizeof(wave));
    memcpy( wave, wavhead, sizeof( wavhead) );
}
int WINAPI MakeSinusoid( char *wav_offs, int len, float corr, char kuu){
double angel=0;
//    kT= Freq*360/88200; //  ( ),      .
    // 360 grad = Pi*2 rad
    if( corr == 0) corr = 1;  //     - . = 1
    kT= Freq*M_PI*2/44100; //  ( ),      .
    len /= 2;
    do{
//         = sin (     ) *  / . / .. / 1,2
        tFlt = sin( angel) * Amp / corr;
//        -        1.2    kUu
        if( kuu ) tFlt = tFlt * kUu / 1.2;
      *((WORD *) (wav_offs)) = (WORD) tFlt;
        wav_offs += 4;  // +4 bytes = RightWord + LeftWord
        angel += kT;
        len--;
        }while( len);
    return 1;
}
int WINAPI MakeWave( int freq, int ampl, float k_correct, int loff, int llen, int roff, int rlen, char kuu){ //  WAV
    ClearWave();    //  WAV
    Amp= ampl; Freq= freq;  //    
    MakeSinusoid( &wave[roff*2+sizeof(wavhead)], rlen, k_correct, kuu);
    MakeSinusoid( &wave[loff*2+2+sizeof(wavhead)], llen, k_correct, kuu);
//    -  ,     PeriodLen()
//   WAV-
//	SaveWav();
    return 1;
}
int WINAPI MakeSWave( int  freq, int ampl, int offset_l, int offset_r){ //  WAV  
int periodLen;
    ClearWave();    //  WAV
    Amp= ampl; Freq= freq;  //    
    periodLen = PeriodLen( freq, freq/2 );    //   ???
	MakeSinusoid( &wave[offset_r*2+sizeof(wavhead)], periodLen, kU, 1);
	MakeSinusoid( &wave[offset_l*2+2+sizeof(wavhead)], periodLen, kU, 1);
//   WAV-
//	SaveWav();
    return 1;
}
int WINAPI FadeWave( int freq, char *offse, int len ){
float f;
// Fade IN
    tInt = (44100/freq) * 2; //  
    kT= f = (1 / (float) tInt);
    lpChar = offse;
    do{
        tFlt = (*((short *) (lpChar)) );
        tFlt *= f;
        *((WORD *) (lpChar)) = (WORD) tFlt;
        lpChar += 4;  // +4 bytes = RightWord + LeftWord
        f += kT;
        tInt--;
    }while( tInt);
// Fade OUT
    tInt = (44100/freq) * 2; //  
    kT= f= (1 / (float) tInt);
    lpChar = (len*2) + offse;
    do{
        tFlt = (*((short *) (lpChar)) );
        tFlt *= f;
        *((WORD *) (lpChar)) = (WORD) tFlt;
        lpChar -= 4;  // -4 bytes = RightWord + LeftWord
        f += kT;
        tInt--;
    }while( tInt);
}
//       
void __fastcall ClearTestStr(){ //     
    U3Iop= U3Iom= U3Uop= U3Uom= U3Uo= 0;
}
void __fastcall CopyTestStr( char testID ){ //     
//       U3Io+  U3Io-
    if( useUu){
        if( U3Iop) U3Iop = (DWORD)((float) U3Iop/kUu);
        if( U3Iom) U3Iom = (DWORD)((float) U3Iom/kUu);
        }
//   
    lpChar = Report;
    while( *((char *) lpChar) ){
        lpChar = &lpChar[25]; // sizeof (testID(1) Freq(4) U3Iop(4) U3Iom(4) U3Uop(4) U3Uom(4) U3Uo(4))
        }
//  
    *((char *) (lpChar)) = testID;
    *((int *) (lpChar+1)) = Freq;
    *((int *) (lpChar+5)) = U3Iop;
    *((int *) (lpChar+9)) = U3Iom;
    *((int *) (lpChar+13)) = U3Uop;
    *((int *) (lpChar+17)) = U3Uom;
    *((int *) (lpChar+21)) = U3Uo;
}
//      
int WINAPI TestLowFreq(int amp1, int amp2, int step, int rlen){
    Freq = 50; //    
    Amp  = (int)((float) amp1*sqrt2); //  
    AmpH = (int)((float) amp2*sqrt2); //  ,    
    AmpI = (int)((float) step*sqrt2); //  
    gStatus &= ~(AMP1|AMP2|AMP3|AMP4|AMP5); //    
    ClearTestStr(); //    
    do{ // 
//            DebugInt( "gStatusTFd1=", gStatus);
        if ( !(gStatus & STATUS_TESTING) ) break;
//     WORD  
        tFlt = Amp/kU50;
        if( useUu ) tFlt = tFlt * kUu; // / 1.2;
        if( tFlt > 0x8000) break; //       - 
//  
        sprintf( &bu[00], "%d", Freq);
        sprintf( &bu[10], "%5.0f", (float) Amp/sqrt2);
        Status( 0, &bu[00], &bu[10], xProgress);
//  
        MakeWave( Freq,Amp ,kU50, 882, 43218, 0, rlen, useUu);
//    
        Out32( 0x379, 0x7F);  //    LPT-
//           
        gStatus |= STATUS_WAVING;
        PlaySound( wave, 0, SND_SYNC|SND_MEMORY);
        gStatus &= ~STATUS_WAVING;
//     
        if( gStatus & AMP5 ) break;
//     
        Amp += AmpI;
        }while( Amp <= AmpH );   // ,           
    CopyTestStr( 2);
 //  ,    
    Sleep( 100);
    return 1;
}
int WINAPI TestFreq(int *offs){ //   
    AmpI = offs[0];
    offs++;
//  ,         
    while( ( offs[0] )&&( gStatus & STATUS_TESTING) ){
        Freq = offs[0]; //    
        Amp  = offs[1]; //  
        AmpH = offs[2]; //  ,    
        xProgress += 5; //  
//  ,    
        Status( 0, "", 0, -1);
        Sleep( 3000);
        ClearTestStr(); //    
        gStatus &= ~(AMP1|AMP2|AMP3|AMP4|AMP5); //    
        do{
//     WORD  
            tFlt = Amp/kU;
            if( useUu ) tFlt = tFlt * kUu / 1.2;
            if( tFlt > 0x8000) break; //       - 
//  
            sprintf( &bu[00], "%d", Freq);
            sprintf( &bu[10], "%d", Amp);
            Status( 0, &bu[00], &bu[10], xProgress);
//  
			MakeWave( Freq,Amp ,kU, 22050, PeriodLen( Freq,Freq/4 ), 0, PeriodLen( Freq,Freq/4 ), useUu);
//     
//&wave[loff*2+2+sizeof(wavhead)], llen
            FadeWave( Freq, &wave[44146], PeriodLen( Freq,Freq/4 ) );
//&wave[roff*2+sizeof(wavhead)], rlen
            FadeWave( Freq, &wave[44], PeriodLen( Freq,Freq/4 ) );
//            SaveWav();
//    
			Out32( 0x379, 0x7F);  //    LPT-
//           
            gStatus |= STATUS_WAVING;
            PlaySound( wave, 0, SND_SYNC|SND_MEMORY);
            gStatus &= ~STATUS_WAVING;
//   ,    4 
#define aaaa AMP1+AMP2+AMP3+AMP4
            if( (gStatus & aaaa) == (aaaa) ) break;
//     
            Amp += AmpI;
            }while( (Amp <= AmpH )&&( gStatus & STATUS_TESTING) );   // ,           
        CopyTestStr( 1);
        offs = &offs[3]; // 12 bytes = 3 sizeof(int)
        }
    return 1;
}
//    
int __fastcall FindMax( short *ofs, int len, short *end){ //     (len - )
short x,max=0;
    x = len;
    len = (int) ((double) len * 1000 / fStep);
    do{
        x = *(ofs);
        if( x < 0 ) x = -x;
        if( x > max) max = x;
        ofs++; len--;
        }while( len && (ofs < end));
    return max;
}
int __fastcall DatToLogic( int nChannel){ //     0  1
short *ls, *lch, *lEnd, x, max=0;
//    
    lch = ls= (nChannel) * nSPC + (short *) MemWork;
    lEnd = ls + nSPC;
//    "-"   
    do{
        x = *(ls);
        if ( x < 0 ){
            x = -x;
            *(ls) = x;
        }
        if ( x > max ) max = x;
        ls++;
    }while( ls < lEnd );
    max = max *2 / 5; //   "1" = 40%  
//   "0"  "1"
    ls = lch;
    do{
        x = *(ls);
//    " 1"
        if( x > max ) x = 1; //  "1"
        else x = 0; //  "0"
        *(ls) = x;
        ls++;
        }while( ls < lEnd );
    return 1;
}
void WINAPI AnalizeLogic(int cOZZ, int cOvz1, int cOvz2, int cOvz3, int cOvz4, int cOkno){ //    
short *ls,*ld, *lch, *lEnd, x,max;
/// Detection StartOZZ (Channel #8)
    ls= ld= nSPC*(cOZZ) + (short *) MemWork;   // Data 8
    lEnd = ls + nSPC; //  
//   "" -     -    
    max = FindMax( ls, 12, lEnd ) *2; //     ""
//     -   - StartOZZ
    do{
        x= *(ls);
        if( x < 0 ) x = -x;
        ls++;
        }while( (max > x) && (ls < lEnd) ); //        
    if( ls < lEnd) StartOZZ = (int) (ls - ld);
    else return;

/// Detection EndOZZ (Channel #8)
//       
    do{
        x= FindMax( ls, 25, lEnd);
        if( x < 0 ) x = -x;
        ls += 1000;
        }while( (max < x) && ls < &ld[nSPC] ); // &ld[nSPC] -  
//       StartOZZ
    max = FindMax( ls, 30, lEnd) + 69;
    do{
        ls--;
        x= *(ls);
        if( x < 0 ) x = -x;
        }while( ( max > x )&&( ls > ld ) );
    EndOZZ = (int) (ls - ld);

/// Detection Okno  (Channel #5)
    DatToLogic( cOkno);
    lch = nSPC*cOkno + (short *) MemWork;   // Logic 5
    ls = lch + (StartOZZ*2);
//         60-80 
  while ( ( okno < 5 )&&( ls > lch ) ){
//   
    while( (*(ls) != 0 )&&( ls > lch )){ //    '1'    
        ls--; }
    if( ls > lch ){ //   '0'   '1'
        ld = ls;
//   
    while( (*(ls) != 1 )&&( ls > lch )){ //    '0'    
        ls--; }
//    -  
    if( ls > lch ) okno = ld - ls;
        StartOkno = ls - lch;
        }
  }

/// Detection OVZ2  (Channel #4)
    DatToLogic( cOvz2);
    lch = nSPC*cOvz2 + (short *) MemWork;   // Logic 4
    lEnd = lch +(StartOZZ/2);
    ls = lch + EndOZZ;
//   2
    while( (*(ls) != 1 )&&( ls > lEnd )){ //    '1'    
        ls--; }
    if( ls > lEnd ){ //    2
        ld = ls;
        EndOVZ2 = ls - lch;
//   2
        while( (*(ls) != 0 )&&( ls > lEnd )){ //    '0'    
            ls--; }
        }
    if( ls > lEnd ) OVZ2 = ld - ls;

/// Detection OVZ4  (Channel #2)
    DatToLogic( cOvz4);
    lch = nSPC*cOvz4 + (short *) MemWork;   // Logic 2
    ls = lch + StartOZZ;
    lEnd = lch + nSPC;
//   4
    while( (*(ls) != 1 )&&( ls < lEnd )){ //    '1'    
        ls++; }
    if( ls < lEnd ){ //   '1'   '0'
        ld = ls;
//   4
        while( (*(ls) != 0 )&&( ls < lEnd )){ //    '0'    
            ls++; }
        }
    if( ls < lEnd ){ //   4 -  
        OVZ4 = ls - ld;
        StartOVZ4 = ld - lch;
        }

/// Detection OVZ1  (Channel #1)
    DatToLogic( cOvz1);
    lch = nSPC*cOvz1 + (short *) MemWork;   // Logic 1
    lEnd = lch + StartOZZ;
    ls = StartOZZ/2 + lch;
    //ld = ls + 1000;
//    1
        while( (*(ls) != 0 )&&( ls < lEnd )){ //    '-'    
            ls++; }
//   1
    while( (*(ls) != 1 )&&( ls < lEnd )){ //    '+'    
        ls++; }
    if( ls < lEnd ){ //   '+'   '-'
        ld = ls;
//   1
        while( (*(ls) != 0 )&&( ls < lEnd )){ //    '-'    
            ls++; }
        }
    if( ls < lEnd ) OVZ1 = ls - ld;

/// Detection OVZ32 (Channel #1)
    if( !EndOZZ) return;
    lEnd = lch + nSPC;
    ls= ld= EndOZZ + lch;
//   1
    while( (*(ls) != 0 )&&( ls < lEnd )){ //    '0'    
        ls++; }
    if( ls < lEnd ){
        OVZ32 = ls - ld;
        }

/// Detection OVZ31 (Channel #6)
    DatToLogic( cOvz3);
    lch = nSPC*cOvz3 + (short *) MemWork; // Logic 6
    lEnd = lch + nSPC;
    ls= ld= lch + EndOZZ ;
//   31
    while( (*(ls) != 0 )&&( ls < lEnd )){ //    '-'    
        ls++; }
    if( ls < lEnd ){
        OVZ31 = ls - ld;
        }
}
//          
int __fastcall OpenDat(){ //    DAT-   
//   
	if( strcmpi( Ext, "dat") ) return 0;
//  .PAR-
	strcpy( bu, File);
	strcpy( bu +strlen( bu) -3, "par" );
    if ( (FileW = fopen( bu, "rb")) == NULL ){
        Error("   .PAR-!");
        return 0; //  .PAR-
        }
    ZeroMemory( bu, sizeof( bu) );
//    fsize = FileW.GetSize();
    readSize = fread( bu, 1, 250, FileW );
    fclose( FileW);
    if ( !readSize ) Error( "readSize = 0" );
//   
    if( strncmp( bu, ParTag, sizeof(ParTag)) ){
        Error("    .DAT/PAR ( '2571090,1618190')!");
        return 0;
        }
//   
    LpData = 0;
//    nChannelsAll = *((WORD *) (bu+46)); // +46 (2)
    nChannels = *((WORD *) (bu+48)); // +48 (2)
    nSPC = *((DWORD *) (bu+50)); // +50 (4) - nSamplesPerChannel - nSPC (word)
	fStep = *((FLOAT *) (bu+58));			//58 (4)
	dMaximum = *((double *) (bu+130));			//130 (8)
//	sprintf( RepTxt, "dMaximum = %f", dMaximum);
//	Error( RepTxt );
//   OPENDAT
	gStatus |= OPENDAT;
	return 1;
}
int __fastcall Open783(){ //    783-   
//   
	if( strcmpi( Ext, "783") ) return 0;
//  
    fseek( FileR, 0, SEEK_SET);
    if( fread( &bu, 1, 30, FileR) != 30 ) return 0; //    - 
//   
    if( strncmp( bu, ".DT1", 4)){
        Error("    .783!");
        return 0;
        }
//   
    LpData = *((DWORD *) (bu+4)); // +4 (4);
//    LpText = *((DWORD *) (bu+8)); // +8 (4);
    nChannels = *((WORD *) (bu+12)); // +12 (2)
//    MapChannel = (*((DWORD *) (bu+14)));	//14 (4) - Map
    fStep = 1000000 / *((DWORD *) (bu+18));	//18 (4) - Freq (Hz)
//    SignalLimit = (*((DWORD *) (bu+22)));	//22 (4) - SignalLimit (mV)
    dMaximum = (double) (*((DWORD *) (bu+22))) / 1000;	//22 (4) - SignalLimit (mV)
	nSPC = *((DWORD *) (bu+26)); // +26 (4) - nSamplesPerChannel - nSPC (word)
//    ChannelSize = nSPC*2; // +26 (4) - nSamplesPerChannel - nSPC (byte)
//    DataSize = ChannelSize * nChannels;
//   OPENDAT
	gStatus |= OPEN783;
	return 1;
}
int __fastcall OpenTXTpg3(){ //    TXT(pg3)-   
//   
	if( strcmpi( Ext, "txt") ) return 0;
//  
    ZeroMemory( bu, sizeof( bu));
    fseek( FileR, 0, SEEK_SET );
    if( !fread( bu, 1, 500, FileR) ) return 0; //    - 
//     
    if( !strstr( bu, "ADC") || !strstr( bu, "Duration") ) return 0;
//   
    sscanf( strstr( bu, "Channels:\t"), "Channels:\t%d", &nChannels);
    sscanf( strstr( bu, "Size:\t"), "Size:\t%d", &nSPC);
    sscanf( strstr( bu, "Step:\t"), "Step:\t%f", &fStep);
/*   fStep -  , ..    */
/*    -  fStep?  (1 / Rate) */
    if( fStep == 0){
        sscanf( strstr( bu, "Rate:\t"), "Rate:\t%f", &fStep);
        fStep = (float ) 1000000 / fStep;
    }
//      (fStep == 0) -    ...
    if( fStep == 0) Error ( "fStep = 0!");
///  
    dMaximum = dMAXIMUMint;
    LpData = strstr( bu, ", V\r\n") - bu +5; // 5 = sizeof(", V\r\n") -     
//    sprintf( bu, "LpData=%d", LpData);
//    Error( bu);
//   OPENTXTPG3
	if( !(nSPC) || !(nChannels) || (fStep == 0) ) return 0;
    gStatus |= OPENTXTPG3;
	return 1;
}
//        
int __fastcall ConvertDat(){ // = Convert783()
short *lIn, *lOut;
int nChan=0;
  do{
	lIn = nChan + (short *) MemIn;
	lOut = nChan * nSPC + (short *) MemWork;
	tInt = 0; //   Sample  
	do{
		*(lOut) = (short) ((double) *(lIn) * dMaximum / dMAXIMUMint );
		lOut++; lIn += nChannels;
		tInt++;
		}while ( tInt < nSPC); //     Samples 
        nChan++;
      }while( nChan < nChannels);
    gStatus |= CONVERTED;
    return 1;
}
int __fastcall ConvertTXTpg3(){
char *ld;
short x=0;
int nChan=0; //    sample
int sample=0; //   sample
// nChennels, nSPC
    Status( "   .TXT",0,0,-1);
    lpChar = (char *) MemIn;
    lpEnd = lpChar + readSize;
/*         ! */
    for( ld=lpChar; ld<lpEnd; ld++)
        if( *(ld) == ',' ) *(ld) = '.';
    do{
//  
        ld = bu;
        ZeroMemory( bu, sizeof(bu) );
///     
        while( lpChar < lpEnd ){
            *(ld) = *(lpChar);
            ld++; lpChar++;
            if( *(lpChar) == '\n') break;
            }
///  
        ld = bu;
//    (..    -  )
        while( (*(ld) != '\t') && ( *(ld) != 0 ) ) ld++;
//     
        if( strlen( ld) > 10){ // 6  = "0 0 0 0 0 0" = 11 
          for ( nChan=0; nChan<nChannels; nChan++){
///   Sample
            sscanf( ld, "\t%f", &tFlt);
//  
//            if( tDbl > dMaximum) dMaximum = tDbl;
//      
            x = (short) ((float) tFlt*1000);
            *((short *) (nChan*nSPC +sample + (short *) MemWork) ) = x;
//            sprintf( RepTxt, "str[%i]=%i\ntFlt=%f", sample, x, tFlt);
//            Error( RepTxt);
//   
            do{ ld++; } while ( (*(ld) != '\t') && (*(ld) != 0) );
            }
          }
///  , ..  sample
        sample++;
        }while( lpChar < lpEnd );
    gStatus |= CONVERTED;
    return 1;
}
//     -
int __fastcall CloseWorkFile(){ //  
#define ooo OPENDAT|OPEN783|OPENTXTPG3
	if( gStatus & ooo){
        fclose( FileR);
		gStatus &= ~ooo;
		}
    return 1;
}
int __fastcall ReadWorkFile(){ //       
    Status( " ",0,0,-1);
    fseek( FileR, 0, SEEK_END);
    readSize = ftell( FileR) -LpData;
//     
    MemIn = malloc( readSize);
//    ZeroMemory( MemIn, readSize);
//    
    fseek( FileR, LpData, SEEK_SET);
    if( (tInt = fread( MemIn, 1, readSize, FileR )) != readSize ){
        sprintf( bu, "ReadWorkFile()\nreadSize= %d from %d", tInt, readSize);
        Error( bu);
        return 0;
    }
// 
    if( gStatus & (OPENDAT|OPEN783) ) ConvertDat();
// Convert783() -  ConvertDat()
    else if( gStatus & OPENTXTPG3) ConvertTXTpg3();
//     
    free( MemIn);
    return 1;
}
int __fastcall OpenWorkFile( char *fname){ //     
//	CloseWorkFile();
    if( (FileR = fopen( fname, "rb")) == NULL ){
        Error( "OpenWorkFile\nfopen( fname, \"rb\")");
        return 0;
    }
    else if( !(OpenDat() || Open783() || OpenTXTpg3() ) ) return 0;
    WriteProfileString( pzzm, lfile, fname);
	return 1; // OK
}
int __fastcall ProcessWorkFile(){ //     
//     
    StartOZZ= EndOZZ= OVZ1= OVZ2= OVZ31= OVZ32= OVZ4= okno = 0;
    EndOVZ2= StartOVZ4= StartOkno= 0;
// 
    if( !OpenWorkFile( File)) return 0;
//    
    szWork = (nChannels * nSPC +1)* 2;
    MemWork = malloc( szWork); // -  * - samples   *  

//   
    ReadWorkFile();
//    MemWork    ,
//    Sample  "signed WORD"  , , 0x0100 = 256 
	if( (gStatus &CONVERTED) ){
//  
// AnalizeLogic( [Start,Stop] [OVZ1,OVZ32] [OVZ2] [OVZ31] [OVZ4] [Okno] );
// DAT
        if( gStatus& (OPENDAT|OPEN783)){
// DAT, 8 channels
            if( nChannels == 8) AnalizeLogic( 7, 0, 3, 5, 1, 4 );
// DAT, 7 channels (    8 ,    " " )
            else if( nChannels == 7) AnalizeLogic( 6, 0, 3, 5, 1, 4 );
// DAT, 6 channels (   7 ,   3,  
            else if( nChannels == 6) AnalizeLogic( 5, 0, 2, 4, 1, 3 );
        }
        else if( gStatus& OPENTXTPG3){
// TXT, 8 channels
            if( nChannels == 8) AnalizeLogic( 1, 2, 5, 7, 3, 6 );
/* TODO (RaSla#5#): --   TXT-7; TXT-6 */
// TXT, 7 channels (    8 ,   #1 -  " " )
            else if( nChannels == 7) AnalizeLogic( 0, 1, 4, 6, 2, 5 );
// TXT, 6 channels
//            else if( nChannels == 6) AnalizeLogic( 6, 0, 3, 5, 1, 4 );
        }
    }
// O    
    free( MemWork);
    return 1;
}

void WINAPI Run( char *cline, char wait){ //    , c/  
STARTUPINFO si;
PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(STARTUPINFO));
	ZeroMemory( &pi, sizeof(PROCESS_INFORMATION));
	CreateProcess( 0, cline,0,0,0, CREATE_NO_WINDOW,0,0, &si, &pi);
	if( wait ) WaitForSingleObject( pi.hProcess, INFINITE);
	CloseHandle( pi.hProcess );
	CloseHandle( pi.hThread );
}
