/* Definitions in the build of inpout32.dll are:            */
/*   short _stdcall Inp32(short PortAddress);               */
/*   void _stdcall Out32(short PortAddress, short data);    */

/* prototype (function typedef) for DLL function Inp32: */

     typedef short (_stdcall *inpfuncPtr)(short portaddr);
     typedef void (_stdcall *oupfuncPtr)(short portaddr, short datum);

#define PPORT_BASE 0x378

/* After successful initialization, these 2 variables
   will contain function pointers.
 */
     inpfuncPtr inp32fp;
     oupfuncPtr oup32fp;

/* Wrapper functions for the function pointers
    - call these functions to perform I/O.
 */
     short  Inp32 (short portaddr){
          return (inp32fp)(portaddr);
     }

     void  Out32 (short portaddr, short datum){
          (oup32fp)(portaddr,datum);
     }

 HINSTANCE hLib;

 //   InpOut32.DLL
 int InpOut32_Init(){
 /* Load the library */
    hLib = LoadLibrary("inpout32.dll");
    if ( hLib != NULL){
        //   ,  
        inp32fp = (inpfuncPtr) GetProcAddress(hLib, "Inp32");
        oup32fp = (oupfuncPtr) GetProcAddress(hLib, "Out32");
        return 1;
        }
    else return 0;
 }

 //     InpOut32.DLL
 int InpOut32_Exit(){
    if (hLib != NULL) FreeLibrary( hLib);
    return 1;
 }
